% read training set into memory and create search structure
function build_db_shapeme( ...
   train, ...
   ftype, ...
   r)

% read features, add to database
for n = 1:length(train.filenames)
   msg = ['added training file ' num2str(n) ' of ' num2str(length(train.filenames)) ' to db'];
   % load exemplar
   [features, x_pos, y_pos] = load_exemplar(train.filenames{n}, ftype);
   % add exemplar to database
   mex_shapeme_db( ...
      'add_exemplar_to_db', ...
      features', ...
      x_pos, ...
      y_pos, ...
      (train.class_id(n) - 1) ...
   );
   disp(msg);
end

% build search structure
disp('building search structure...');
mex_shapeme_db('build_db',r);
